'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _rest = require('./rest');

var _rest2 = _interopRequireDefault(_rest);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function camelCaseToDash(myStr) {
  return myStr.replace(/([a-z])([A-Z])/g, '$1-$2').toLowerCase();
}

const sendForvoRequest = ({ key, action, requiredParams, optionalParams }) => {
  const url = [{ name: 'key', value: key }, { name: 'format', value: 'json' }, { name: 'action', value: action }, ...requiredParams, ...Object.keys(optionalParams).map(key => ({ name: key, value: optionalParams[key] }))].reduce((url, { name, value }) => {
    return [url, camelCaseToDash(name), value].join('/');
  }, 'https://apifree.forvo.com');
  return _rest2.default.GET(url);
};

const forvoApi = ({ key }) => {
  return {
    wordPronunciations: (_ref) => {
      let word = _ref.word,
          options = _objectWithoutProperties(_ref, ['word']);

      return sendForvoRequest({
        key,
        action: 'word-pronunciations',
        requiredParams: [{ name: 'word', value: word }],
        optionalParams: options
      });
    }
  };
};

exports.default = forvoApi;